leetcode 两数之和

给定一个整数数组和一个目标值,找出数组中和为目标值的两个数。

你可以假设每个输入只对应一种答案,且同样的元素不能被重复利用。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

解法:

 该实现时间复杂度是O(N),空间复杂度为O(N).
     *依赖hashMap数据结构,存放每个元素。
     * 顺序遍历数组元素,求出当前元素与target的差值,同时检查已存在Map中的元素,是否存在这个差值。
     * 为什么向需要考虑已加入Map的数据,是因为,即使后面有target元素,那么在迭代到后面肯定可以找到之前的target,所以一次遍历就够了。

 

package easy;

import java.util.HashMap;

/**
 * 给定一个整数数组和一个目标值,找出数组中和为目标值的两个数。
 示例:
 给定 nums = [2, 7, 11, 15], target = 9
 因为 nums[0] + nums[1] = 2 + 7 = 9
 所以返回 [0, 1]
 */
public class TwoSum {
    /**
     * 该实现时间复杂度是O(N),空间复杂度为O(N).
     * 依赖hashMap数据结构,存放每个元素。
     * 顺序遍历数组元素,求出当前元素与target的差值,同时检查已存在Map中的元素,是否存在这个差值。
     * 为什么向需要考虑已加入Map的数据,是因为,即使后面有target元素,那么在迭代到后面肯定可以找到之前的target,所以一次遍历就够了。
     *
     * @param nums
     * @param target
     * @return
     */
    public static  int[] twoSum(int[] nums, int target) {
        HashMap<Integer,Integer> index = new HashMap<Integer, Integer>();
        for (int i = 0; i < nums.length; i++) {
            int complement = target - nums[i];
            if(index.containsKey(complement)){
                return new int[]{index.get(complement),i};
            }
            index.put(nums[i],i);
        }
        throw new IllegalArgumentException("No two sum solution");
    }

    public static void main(String[] args) {
        int[] nums = new int[]{1,2,3,4,5,6,7,9,11,23};
        int target = 8;
        for (int a: twoSum(nums,target)) {
            System.out.println("index="+a+",value="+nums[a]);
        }
    }
}

 

  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值